'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  href: _propTypes2.default.string,
  isBorderless: _propTypes2.default.bool,
  isDisabled: _propTypes2.default.bool,
  isError: _propTypes2.default.bool,
  isFilled: _propTypes2.default.bool,
  isPrimary: _propTypes2.default.bool,
  isRounded: _propTypes2.default.bool,
  isSecondary: _propTypes2.default.bool,
  isSmall: _propTypes2.default.bool,
  onClick: _propTypes2.default.func,
  tabIndex: _propTypes2.default.number,
  target: _propTypes2.default.string,
  text: _propTypes2.default.string,
  type: _propTypes2.default.string
};

var defaultProps = { type: 'button' };

var Button = function Button(props) {
  var newProps = {
    className: (0, _classnames2.default)('pl-button', props.className, {
      'pl-borderless': props.isBorderless,
      'pl-disabled': props.isDisabled,
      'pl-error': props.isError,
      'pl-filled': props.isFilled,
      'pl-primary': props.isPrimary,
      'pl-rounded': props.isRounded,
      'pl-secondary': props.isSecondary,
      'pl-small': props.isSmall
    }),
    disabled: props.isDisabled,
    tabIndex: props.tabIndex
  };

  if (!props.isDisabled) {
    if (props.href) {
      newProps.href = props.href;
      newProps.target = props.target;
    } else {
      newProps.onClick = props.onClick;
      newProps.type = props.type;
    }
  }

  var children = props.children || props.text;
  return props.href ? _react2.default.createElement(
    'a',
    newProps,
    children
  ) : _react2.default.createElement(
    'button',
    newProps,
    children
  );
};

Button.propTypes = propTypes;
Button.defaultProps = defaultProps;

exports.default = Button;