'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _button = require('./button');

var _button2 = _interopRequireDefault(_button);

var _icon = require('./icon');

var _icon2 = _interopRequireDefault(_icon);

var _overlay = require('./overlay');

var _overlay2 = _interopRequireDefault(_overlay);

var _keys = require('../../util/keys');

var keys = _interopRequireWildcard(_keys);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Dialog = (0, _createReactClass2.default)({
  displayName: 'Dialog',

  propTypes: {
    buttons: _propTypes2.default.array,
    children: _propTypes2.default.node,
    className: _propTypes2.default.string,
    footer: _propTypes2.default.node,
    header: _propTypes2.default.node,
    isLarge: _propTypes2.default.bool,
    isSmall: _propTypes2.default.bool,
    onClose: _propTypes2.default.func,
    onScroll: _propTypes2.default.func,
    onSubmit: _propTypes2.default.func,
    shouldAnimateIn: _propTypes2.default.bool,
    title: _propTypes2.default.string
  },

  getDefaultProps: function getDefaultProps() {
    return {
      buttons: [],
      shouldAnimateIn: true
    };
  },
  componentWillMount: function componentWillMount() {
    window.addEventListener('keydown', this.onKeyDown, true);
  },
  componentWillUnmount: function componentWillUnmount(nextProps) {
    window.removeEventListener('keydown', this.onKeyDown, true);
  },
  onKeyDown: function onKeyDown(event) {
    if (this.props.onClose && event.keyCode === keys.ESC) {
      event.stopPropagation();
      this.props.onClose();
    }
  },
  onSubmit: function onSubmit(event) {
    event.preventDefault();
    if (this.props.onSubmit) {
      this.props.onSubmit();
    }
  },
  render: function render() {
    var _this = this;

    var dialogClassName = (0, _classnames2.default)('pl-dialog', this.props.className, {
      'pl-large': this.props.isLarge,
      'pl-small': this.props.isSmall
    });
    return _react2.default.createElement(
      _overlay2.default,
      {
        className: dialogClassName,
        onDimClick: this.props.onClose,
        shouldAnimateIn: this.props.shouldAnimateIn
      },
      _react2.default.createElement(
        'form',
        { onSubmit: this.onSubmit },
        this.props.title && _react2.default.createElement(
          'div',
          { className: 'pl-dialog-header' },
          _react2.default.createElement(
            'h4',
            null,
            this.props.title
          ),
          this.props.onClose && _react2.default.createElement(
            'div',
            {
              className: 'pl-dialog-header-close',
              onClick: this.props.onClose
            },
            _react2.default.createElement(_icon2.default, { name: 'close' })
          ),
          this.props.header
        ),
        _react2.default.createElement(
          'div',
          {
            className: 'pl-dialog-content',
            onScroll: this.props.onScroll,
            ref: function ref(_ref) {
              return _this.content = _ref;
            }
          },
          this.props.children
        ),
        this.props.buttons.length > 0 && _react2.default.createElement(
          'div',
          { className: 'pl-dialog-footer' },
          this.props.footer,
          this.props.buttons.map(function (button, index) {
            return _react2.default.createElement(_button2.default, _extends({}, button, {
              className: button.left ? 'pl-left' : null,
              key: button.text
            }));
          })
        )
      )
    );
  }
});

exports.default = Dialog;