'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var baseClass = 'pl-ui-form-input';

var propTypes = {
  hasError: _propTypes2.default.bool,
  isDisabled: _propTypes2.default.bool,
  isRequired: _propTypes2.default.bool,
  onChange: _propTypes2.default.func.isRequired,
  optionalText: _propTypes2.default.string,
  value: _propTypes2.default.string.isRequired
};

var defaultProps = {
  hasError: false,
  isRequired: true,
  optionalText: '(Optional)'
};

/* This is a controlled input, meaning the value of the input is determined
 * by the value of the prop. Changes to the input in the DOM invoke the
 * 'handleChange' function, which is a mandatory prop. This function will be
 * responsible for updating the parent, which will ultimately propogate back
 * down to this form input in the form of a new "value" prop
 */
var FormInput = function FormInput(_ref) {
  var hasError = _ref.hasError,
      isDisabled = _ref.isDisabled,
      isRequired = _ref.isRequired,
      onChange = _ref.onChange,
      value = _ref.value,
      optionalText = _ref.optionalText,
      props = _objectWithoutProperties(_ref, ['hasError', 'isDisabled', 'isRequired', 'onChange', 'value', 'optionalText']);

  var handleChange = function handleChange(event) {
    onChange(event.target.value);
  };

  var optionalBlock = !isRequired ? _react2.default.createElement(
    'div',
    { className: baseClass + '__optional-text' },
    optionalText
  ) : null;

  var errorStrip = hasError ? _react2.default.createElement('div', { className: 'pl-ui-form-input__error-strip' }) : null;

  return _react2.default.createElement(
    'div',
    { className: '' + baseClass },
    optionalBlock,
    errorStrip,
    _react2.default.createElement('input', _extends({
      disabled: isDisabled,
      onChange: handleChange,
      value: value
    }, props))
  );
};

FormInput.baseClass = baseClass;
FormInput.propTypes = propTypes;
FormInput.defaultProps = defaultProps;

exports.default = FormInput;