'use strict';

var del = require('del');
var gulp = require('gulp');
var babel = require('gulp-babel');
var less = require('gulp-less');
var gutil = require('gulp-util');
var LessPluginAutoPrefix = require('less-plugin-autoprefix');
var LessPluginCleanCSS = require('less-plugin-clean-css');
var sequence = require('run-sequence');

var LIB_DIR = './lib/';

gulp.task('clean', function () {
  return del(LIB_DIR);
});

gulp.task('script', function () {
  return gulp.src('./!(*.test).js').pipe(babel({ presets: ['es2015', 'react'] })).pipe(gulp.dest(LIB_DIR));
});

gulp.task('style', function () {
  gulp.src('./*.less').pipe(less({
    relativeUrls: true,
    plugins: [new LessPluginAutoPrefix(), new LessPluginCleanCSS()]
  })).on('error', function (err) {
    gutil.log('LESS compilation failed: ' + err.message);
    process.exit(1);
  }).pipe(gulp.dest(LIB_DIR));
});

gulp.task('default', function (done) {
  sequence('clean', ['script', 'style'], done);
});