'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _icons = require('./icons');

var _icons2 = _interopRequireDefault(_icons);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var parser = new DOMParser();

var propTypes = {
  className: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired,
  style: _propTypes2.default.object
};

var Icon = function Icon(props) {
  if (!_icons2.default[props.name]) {
    return null;
  }

  var shapes = [];
  var icon = parser.parseFromString(_icons2.default[props.name], 'image/svg+xml').childNodes[0];
  for (var i = 0; i < icon.childNodes.length; i++) {
    var childNode = icon.childNodes.item(i);
    if (childNode.nodeType === 1 && childNode.tagName !== 'title') {
      var attributes = Array.prototype.slice.call(childNode.attributes, 0);
      shapes.push({
        tagName: childNode.tagName,
        attributes: attributes.reduce(function (a, b) {
          a[b.name] = b.value;
          return a;
        }, {})
      });
    }
  }

  return _react2.default.createElement(
    'svg',
    {
      className: (0, _classnames2.default)('pl-icon', props.className),
      style: props.style,
      viewBox: icon.attributes.viewBox.value,
      xmlns: 'http://www.w3.org/2000/svg'
    },
    shapes.map(function (shape, index) {
      return _react2.default.createElement(shape.tagName, Object.assign({ key: index }, shape.attributes));
    })
  );
};

Icon.propTypes = propTypes;

exports.default = Icon;