'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  children: _propTypes2.default.node.isRequired,
  className: _propTypes2.default.string,
  onDimClick: _propTypes2.default.func,
  onDragEnter: _propTypes2.default.func,
  onDragLeave: _propTypes2.default.func,
  onDragOver: _propTypes2.default.func,
  onDrop: _propTypes2.default.func,
  shouldAnimateIn: _propTypes2.default.bool
};

var Overlay = function Overlay(props) {
  var overlayClassName = (0, _classnames2.default)('pl-overlay', props.className, {
    'pl-overlay--no-animate': !props.shouldAnimateIn
  });

  return _react2.default.createElement(
    'div',
    {
      className: overlayClassName,
      onDragEnter: props.onDragEnter,
      onDragLeave: props.onDragLeave,
      onDragOver: props.onDragOver,
      onDrop: props.onDrop
    },
    _react2.default.createElement('div', { className: 'pl-overlay-dim', onClick: props.onDimClick }),
    _react2.default.createElement(
      'div',
      { className: 'pl-overlay-content' },
      props.children
    )
  );
};

Overlay.propTypes = propTypes;

exports.default = Overlay;