'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var TabMenu = (0, _createReactClass2.default)({
  displayName: 'TabMenu',

  propTypes: {
    activeIndex: _propTypes2.default.number,
    className: _propTypes2.default.string,
    onChange: _propTypes2.default.func,
    tabs: _propTypes2.default.array
  },

  getInitialState: function getInitialState() {
    return {
      activeIndex: this.props.activeIndex || 0
    };
  },
  componentWillReceiveProps: function componentWillReceiveProps(nextProps) {
    if (nextProps.activeIndex !== this.props.activeIndex) {
      this.setState({ activeIndex: nextProps.activeIndex });
    }
  },
  onHeaderItemClick: function onHeaderItemClick(index) {
    this.setState({ activeIndex: index }, function () {
      if (this.props.onChange) {
        this.props.onChange(index);
      }
    });
  },
  render: function render() {
    var _this = this;

    return _react2.default.createElement(
      'div',
      { className: (0, _classnames2.default)('pl-tab-menu', this.props.className) },
      _react2.default.createElement(
        'div',
        { className: 'pl-tab-menu-header' },
        this.props.tabs.map(function (tab, index, array) {
          var _classNames;

          var headerItemClassName = (0, _classnames2.default)('pl-tab-menu-header-item', (_classNames = {}, _defineProperty(_classNames, tab.id, true), _defineProperty(_classNames, 'pl-active', index === _this.state.activeIndex), _classNames));
          return _react2.default.createElement(
            'div',
            {
              className: headerItemClassName,
              key: tab.id,
              onClick: function onClick() {
                return _this.onHeaderItemClick(index);
              },
              style: { zIndex: array.length - index }
            },
            _react2.default.createElement(
              'span',
              null,
              tab.title
            )
          );
        })
      ),
      _react2.default.createElement(
        'div',
        { className: 'pl-tab-menu-slides' },
        _react2.default.createElement(
          'div',
          {
            className: 'pl-tab-menu-slider',
            style: { transform: 'translateX(' + this.state.activeIndex * -100 + '%)' }
          },
          this.props.tabs.map(function (tab, index) {
            return _react2.default.createElement(
              'div',
              { className: 'pl-tab-menu-slide', key: tab.id },
              tab.content
            );
          })
        )
      )
    );
  }
});

exports.default = TabMenu;