'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _createReactClass = require('create-react-class');

var _createReactClass2 = _interopRequireDefault(_createReactClass);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  className: _propTypes2.default.string,
  isActive: _propTypes2.default.bool.isRequired,
  isDisabled: _propTypes2.default.bool,
  label: _propTypes2.default.string,
  name: _propTypes2.default.string,
  onToggle: _propTypes2.default.func
};

var Toggle = (0, _createReactClass2.default)({
  displayName: 'Toggle',

  onToggle: function onToggle() {
    if (!this.props.isDisabled && this.props.onToggle) {
      this.props.onToggle(!this.props.isActive);
    }
  },
  render: function render() {
    var toggleClassName = (0, _classnames2.default)('pl-toggle', this.props.className, {
      'pl-active': this.props.isActive,
      'pl-disabled': this.props.isDisabled || !this.props.onToggle
    });
    return _react2.default.createElement(
      'div',
      { className: toggleClassName, onClick: this.onToggle },
      _react2.default.createElement('input', {
        checked: this.props.isActive,
        name: this.props.name,
        readOnly: true,
        type: 'checkbox'
      }),
      _react2.default.createElement(
        'div',
        { className: 'pl-toggle-switch' },
        _react2.default.createElement('div', { className: 'pl-toggle-switch-track' }),
        _react2.default.createElement('div', { className: 'pl-toggle-switch-handle' })
      ),
      this.props.label && _react2.default.createElement(
        'label',
        null,
        this.props.label
      ),
      _react2.default.createElement('div', { className: 'pl-clear' })
    );
  }
});

Toggle.propTypes = propTypes;

exports.default = Toggle;