'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  position: _propTypes2.default.string
};

var Tooltip = function Tooltip(props) {
  var tooltipClassName = (0, _classnames2.default)('pl-tooltip', props.className);

  var position = props.position ? props.position.split(' ').slice(0, 2) : [];
  var tooltipLabelClassName = (0, _classnames2.default)('pl-tooltip-label', {
    'pl-top': position.indexOf('top') !== -1,
    'pl-right': position.indexOf('right') !== -1,
    'pl-bottom': position.indexOf('bottom') !== -1,
    'pl-left': position.indexOf('left') !== -1
  });

  return _react2.default.createElement(
    'div',
    { className: tooltipClassName, onClick: props.onClick },
    _react2.default.createElement('div', { className: 'pl-tooltip-target' }),
    _react2.default.createElement(
      'div',
      { className: tooltipLabelClassName },
      props.children
    )
  );
};

Tooltip.propTypes = propTypes;

exports.default = Tooltip;